

extern double TakeProfit = 50;
extern double Lots = 1;
extern double TrailingStop = 30;
extern int     adxPeriod=60;
extern int     shiftt=3;
extern double sarStep=0.02;
extern double sarMax=0.2;



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double adxplus, adxminus, adxbase, sar;
   double semaphore=1;
   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   adxplus=iADX(NULL,0,adxPeriod,PRICE_CLOSE,MODE_PLUSDI,0);
   adxminus=iADX(NULL,0,adxPeriod,PRICE_CLOSE,MODE_MINUSDI,0);
   adxbase=iADX(NULL,0,adxPeriod,PRICE_CLOSE,MODE_BASE,0);
   sar=iSAR(NULL,0,sarStep,sarMax,0);
   
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
        for (cnt=0; cnt<shiftt; cnt++)
        {
         if( iADX(NULL,0,adxPeriod,PRICE_CLOSE,MODE_BASE,cnt) <= iADX(NULL,0,adxPeriod,PRICE_CLOSE,MODE_BASE,cnt+1) ) 
            semaphore=-1;
        }   
      // check for long position (BUY) possibility
      if(semaphore>0 && adxplus > adxminus && sar<Close[0])
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"adxsar",15364,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else {
            Print("Error opening BUY order : ",GetLastError());
            Print("OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,macd sample,15364,0,Green)");
            Print("Lots ", Lots);
            Print("ask ", Ask);
            Print("ask+takeprofit: ", Ask+TakeProfit*Point);
            
         } 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(semaphore>0 && adxplus < adxminus && sar < Close[0])
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"adxsar",15364,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(sar>Close[0])
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(sar < Close[0])
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.